package org.simantics.db.layer0.adapter.impl;

import java.util.Collection;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.layer0.adapter.CopyHandler2;
import org.simantics.db.layer0.adapter.impl.DefaultCopyHandler;
import org.simantics.db.layer0.util.TransferableGraphConfiguration2;

public class MoveCopyHandler extends DefaultCopyHandler {

	public MoveCopyHandler(Resource composite) {
		super(composite);
	}
	
    public MoveCopyHandler(Collection<Resource> composites) {
        super(composites);
    }
	
	@Override
	protected CopyHandler2 create(Collection<Resource> resources) {
	    return new MoveCopyHandler(resources);
	}
	
	@Override
	protected TransferableGraphConfiguration2 createConfiguration(ReadGraph graph, boolean cut) throws DatabaseException {
		if(cut) return null;
		else return super.createConfiguration(graph, cut);
	}

}
